#include <stdio.h>
//#include <alloc.h>
#include <conio.h>
#include "baselist.hpp"

#define     BLOCKSIZE           102400
#define     ITEMS               40

class Block
{
    public:
        char data[BLOCKSIZE];

        int operator ==(Block &b)    { return(0); }
};

typedef     BaseList<Block>    BlockList;


void main( void )
{
    int     i;
    Block      blk;
    BlockList   L;
    unsigned long    freeprev=0L, freeaftr=0L;


    printf("BaseList tester\n---------------\n");
    
    //freeprev=coreleft();
    printf("\nInitial free memory : %u\n",freeprev);

    printf("\nInitializing temp block...");
    for ( i=0; i<BLOCKSIZE; i++ )  blk.data[i]=(char)i;
    printf("done.\n");  //delay(2000);

    printf("\nAdding blocks to list...\n");
    for ( i=0; i<ITEMS; i++ )
    {
        printf("\tblock #%3d  -->  ",i+1);
        /*freeprev=coreleft();*/ 
        if (L.addAtHead(blk))
          { printf("OK    (mem.free=%u)\n",freeprev); }
        else
          { printf("FAIL  (mem.free=%u)\n",freeprev); break; }
    }
    printf("done.\n");  //delay(2000);

    printf("\nDestroying list blocks...");
    L.done();
    printf("done.\n");  //delay(2000);

    getch();
    //freeaftr=coreleft();
    printf("\nFinal free memory : %u\n",freeaftr);
    printf("Memory leaks = %u bytes\n",freeprev-freeaftr);
    printf("Block size = %u  ,  Items = %u\n\n",sizeof(Block),ITEMS);
}



